//
// Kodulabori Kontrollerimooduli arvutiga RS-232 kaudu liidestamine.
// Näide kasutab Digitaalset sisend-väljundmoodulit koos LCD ekraaniga.
// Arvuti terminalis sisestatud tekst kuvatakse LCD-l.
//
#include <homelab/usart.h>
#include <homelab/module/lcd_alpha.h>
#include <homelab/pin.h>
#include <util/delay.h>
#include <homelab/module/lcd_gfx.h>

char c;
int kiirus = 3;

#define mootor1_edasi PORTB = (1 << PIN4) | (0 << PIN7);
#define mootor1_tagasi PORTB = (0 << PIN4) | (1 << PIN7);
#define mootor1_seis PORTB = (0 << PIN4) | (0 << PIN7);
#define mootor2_edasi PORTD = (1 << PIN0) | (0 << PIN1);
#define mootor2_tagasi PORTD = (0 << PIN0) | (1 << PIN1);
#define mootor2_seis PORTD = (0 << PIN0) | (0 << PIN1);

// Kiirus, mootorite nrkuse tttu ei tta

void kaik(void)
{
    if(c == 'i') kiirus = 1;
    if(c == 'j') kiirus = 2;
    if(c == 'k') kiirus = 3;
}

// Mootorite sidusuund

void mootor(void)
{
    if(kiirus == 1) {_delay_ms(5); mootor1_seis; mootor2_seis;_delay_ms(5); }
    if(kiirus == 2) {_delay_ms(2); mootor1_seis; mootor2_seis;_delay_ms(2); }
    if(c == 'a') { mootor1_tagasi; mootor2_tagasi; }
    else if(c == 'b') { mootor1_edasi; mootor2_edasi; }
    else if(c == 'c') { mootor1_tagasi; mootor2_seis; }
    else if(c == 'd') { mootor1_edasi; mootor2_seis;  }
    else if(c == 'e') { mootor1_tagasi; mootor2_edasi; }
    else if(c == 'f') { mootor1_edasi; mootor2_tagasi; }
    else if(c == 'g') { mootor1_seis; mootor2_edasi; }
    else if(c == 'h') { mootor1_seis; mootor2_tagasi; }
    else if(c == 'x') { mootor1_seis; mootor2_seis; }
}
//
// USART liidese määramine
//
usart port = USART(1);
 
//
// Põhiprogramm
//
int main(void)
{


    // Ekraani seadistamine
    // Ekraani seadistamine
    //lcd_alpha_init(LCD_ALPHA_DISP_ON);


    DDRD |=  (1 << PIN0) | (1 << PIN1);
    DDRB |=  (1 << PIN4) | (1 << PIN7);

    // nupud ja ledid testimiseks
    
    pin led =  PIN(C, 3);
    pin led2 =  PIN(C, 4);
    pin led3 =  PIN(C, 5);
    pin nupp = PIN(C, 1);

    pin_setup_output(led);
    pin_setup_input(nupp);
    pin_setup_output(led2);
    pin_setup_output(led3);
    pin_set_to(led, 1);
    pin_set_to(led2, 1);
    pin_set_to(led3, 1);

    // USART liidese seadistamine
    usart_init_async(port,
        USART_DATABITS_8,
        USART_STOPBITS_ONE,
        USART_PARITY_NONE,
        USART_BAUDRATE_ASYNC(9600));

    // LCD ekraani puhastamine
    //lcd_alpha_clear();
 


    // Lõputu tsükkel
    while (true)
    {
        
        // Jadaliidesest märgi lugemine
        if (usart_try_read_char(port, &c))
        {   
            //pin_set_to(led3, 0);
        }

        kaik();
        mootor();
    }
}
